% Devereux, Senay and Sutherland (2013) Figure 1 and Table 1

clear all

load('dss-table1-figure1-matlab-data.mat');

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

wy=6;
sst=1;
snd=38;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

cix1=zeros(179,4);
cix1(8,1)  =1; cix1(8,2)  =0; cix1(8,3)  =1; cix1(8,4)  =1;    % Australia
cix1(9,1)  =1; cix1(9,2)  =0; cix1(9,3)  =1; cix1(9,4)  =1;    % Austria
cix1(14,1) =1; cix1(14,2) =0; cix1(14,3) =1; cix1(14,4) =1;    % Belgium
cix1(28,1) =1; cix1(28,2) =1; cix1(28,3) =1; cix1(28,4) =1;    % Canada
cix1(44,1) =1; cix1(44,2) =0; cix1(44,3) =1; cix1(44,4) =1;    % Denmark
cix1(57,1) =1; cix1(57,2) =0; cix1(57,3) =1; cix1(57,4) =1;    % Finland
cix1(58,1) =1; cix1(58,2) =1; cix1(58,3) =1; cix1(58,4) =1;    % France
cix1(62,1) =1; cix1(62,2) =1; cix1(62,3) =1; cix1(62,4) =1;    % Germany
cix1(64,1) =1; cix1(64,2) =0; cix1(64,3) =1; cix1(64,4) =1;    % Greece
cix1(78,1) =1; cix1(78,2) =0; cix1(78,3) =1; cix1(78,4) =1;    % Ireland
cix1(80,1) =1; cix1(80,2) =1; cix1(80,3) =1; cix1(80,4) =1;    % Italy
cix1(82,1) =1; cix1(82,2) =1; cix1(82,3) =1; cix1(82,4) =1;    % Japan
cix1(87,1) =1; cix1(87,2) =0; cix1(87,3) =0; cix1(87,4) =0;    % Korea
cix1(115,1)=1; cix1(115,2)=0; cix1(115,3)=1; cix1(115,4)=1;    % Netherlands
cix1(116,1)=1; cix1(116,2)=0; cix1(116,3)=0; cix1(116,4)=0;    % New Zealand
cix1(120,1)=1; cix1(120,2)=0; cix1(120,3)=1; cix1(120,4)=1;    % Norway
cix1(129,1)=1; cix1(129,2)=0; cix1(129,3)=1; cix1(129,4)=1;    % Portugal
cix1(146,1)=1; cix1(146,2)=0; cix1(146,3)=1; cix1(146,4)=1;    % Spain
cix1(153,1)=1; cix1(153,2)=0; cix1(153,3)=1; cix1(153,4)=1;    % Sweden
cix1(154,1)=1; cix1(154,2)=0; cix1(154,3)=1; cix1(154,4)=1;    % Switzerland
cix1(170,1)=1; cix1(170,2)=1; cix1(170,3)=1; cix1(170,4)=1;    % UK
cix1(171,1)=1; cix1(171,2)=1; cix1(171,3)=1; cix1(171,4)=1;    % USA

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% inflation, 1960 - 2007, 192 quarterly observations, 48 years

wnd=4*wy;
nyrs=48-wy+1;
nyrd=nyrs-38+1;

for ic=1:159
    im=2;
    tmp1(ic,1)=inflation(ic,1);
    for iy=1:nyrs
        tmp1(ic,iy+1)=std(inflation(ic,im:im+wnd-1));
        im=im+4;
    end    
end  

for ilmf=1:179

    ccd1=lanedata(1,1,ilmf);
    for iy=1:38
        lanedata(iy,38,ilmf)=-1000;
    end
    for ic=1:159
        ccd2=tmp1(ic,1);
        if ccd1==ccd2
            for iy=1:38
                lanedata(iy,38,ilmf)=tmp1(ic,iy+nyrd);
            end    
        end
    end    
        
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% exchange rate level, 1964 - 2007, 528 monthly observations, 44 years
% exchange rate change, 1965 - 2007, 516 monthly observations, 43 years

wnd=12*wy;
nyrs=43-wy+1;
nyrd=nyrs-38+1;

for ic=1:26
    for t=14:529
        tmp2(ic,t-13)=((exrate(ic,t)/exrate(ic,t-12))-1)*100;
    end    
end   

for ic=1:26
    im=1;
    tmp3(ic,1)=exrate(ic,1);
    for iy=1:nyrs
        tmp3(ic,iy+1)=std(tmp2(ic,im:im+wnd-1));
        im=im+12;
    end    
end  

for ilmf=1:179
    ccd1=lanedata(1,1,ilmf);
    for iy=1:38
        lanedata(iy,39,ilmf)=-1000;
    end
    for ic=1:26
        ccd2=tmp3(ic,1);
        if ccd1==ccd2
            for iy=1:38
                if iy+nyrd>1
                    lanedata(iy,39,ilmf)=tmp3(ic,iy+nyrd);
                end    
            end    
        end
    end          
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% trade, 1960 - 2007, 48 annual observations

nyrs=48;
nyrd=nyrs-38+1;

for ic=1:22
    trade(ic,1)=imports(ic,1);
    for t=1:48
        trade(ic,t+1)=100*(imports(ic,t+1)+exports(ic,t+1))/ngdp(ic,t+1);
        if trade(ic,t+1)==0
            trade(ic,t+1)=-1000;
        end    
    end
end

for ilmf=1:179
    ccd1=lanedata(1,1,ilmf);
    for iy=1:38
        lanedata(iy,46,ilmf)=-1000;
    end
    for ic=1:22
        ccd2=trade(ic,1);
        if ccd1==ccd2
            for iy=1:38
                lanedata(iy,46,ilmf)=trade(ic,iy+nyrd);
            end    
        end
    end          
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% gdp, 1960 - 2007, 48 annual observations

wnd=wy;
nyrs=48-wy+1;
nyrd=nyrs-38+1;

for ic=1:22
    im=2;
    tmp4(ic,1)=gdp(ic,1);
    for iy=1:nyrs
        iz=0;
        tmp4(ic,iy+1)=-1000;
        for ix=im:im+wnd-1
            if gdp(ic,ix)>-100
                iz=iz+1;
                tmp5(iz)=gdp(ic,ix);
            end    
        end
        if iz>=5
            tmp4(ic,iy+1)=std(tmp5(1:iz),1);
        end    
        im=im+1;
    end    
end 

for ilmf=1:179
    ccd1=lanedata(1,1,ilmf);
    for iy=1:38
        lanedata(iy,47,ilmf)=-1000;
    end
    for ic=1:22
        ccd2=tmp4(ic,1);
        if ccd1==ccd2
            for iy=1:38
                lanedata(iy,47,ilmf)=tmp4(ic,iy+nyrd);
            end    
        end
    end          
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

ix=0;
iy=1;
for i=1:748
    ix=ix+1;
    cbi1(iy,1)=gdp(iy,1);
    cbi1(iy,2)=-1000;
    cbi1(iy,3)=-1000;
    cbi1(iy,38)=-1000;
    cbi1(iy,39)=-1000;
    cbi1(iy,ix+3)=cbi(i,1);
    if ix==34
        ix=0;
        iy=iy+1;
    end
end 

for ilmf=1:179
    ccd1=lanedata(1,1,ilmf);
    for iy=1:38
        lanedata(iy,48,ilmf)=-1000;
    end
    for ic=1:22
        ccd2=cbi1(ic,1);
        if ccd1==ccd2
            for iy=1:38
                lanedata(iy,48,ilmf)=cbi1(ic,iy+1);
            end    
        end
    end          
end
            
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

ix=1;
tst{ix,1}='country';
tst{ix,2}='year';
tst{ix,3}='g7';
tst{ix,4}='oecd70';
tst{ix,5}='oecd72';
tst{ix,6}='equity';
tst{ix,7}='debt';
tst{ix,8}='gport';
tst{ix,9}='chinn';
tst{ix,10}='sdi';
tst{ix,11}='sdy';
tst{ix,12}='trade';
tst{ix,13}='sds';
tst{ix,14}='time';
tst{ix,15}='cbi';
tst{ix,16}='equity1';
tst{ix,17}='debt1';
tst{ix,18}='gport1';
for ic=1:179
    if cix1(ic,1)==1;
        for i=1:38
            ix=ix+1;
            tst{ix,1}=country{ic,1};
            tst{ix,2}=1969+i;
            tst{ix,3}=cix1(ic,2);
            tst{ix,4}=cix1(ic,3);
            tst{ix,5}=cix1(ic,4);
            tst{ix,6}=lanedata(i,34,ic);
            tst{ix,7}=lanedata(i,35,ic);
            tst{ix,8}=lanedata(i,41,ic);
            tst{ix,9}=lanedata(i,37,ic);
            tst{ix,10}=lanedata(i,38,ic);
            tst{ix,11}=lanedata(i,47,ic);
            tst{ix,12}=lanedata(i,46,ic);
            tst{ix,13}=lanedata(i,39,ic);
            tst{ix,14}=i;
            tst{ix,15}=lanedata(i,48,ic);
            tst{ix,16}=100*log(lanedata(i,34,ic));
            tst{ix,17}=100*log(lanedata(i,35,ic));
            tst{ix,18}=100*log(lanedata(i,41,ic));          
        end    
    end
end 

for i=2:ix
    for j=6:18
        if isnan(tst{i,j})
            tst{i,j}=' ';
        end
        if tst{i,j}==0
            tst{i,j}=' ';
        end
        if tst{i,j}==-1000
            tst{i,j}=' ';
        end
    end
end  

% xlswrite('tst10.xlsx',tst);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

clear sm sm1 sm2 sm3 sm4 sm5 sm6 sm7

vr=41;
for t=1:38
    sm1(t,1)=lanedata(t,vr,28);
    sm1(t,2)=lanedata(t,vr,58);
    sm1(t,3)=lanedata(t,vr,62);
    sm1(t,4)=lanedata(t,vr,80);
    sm1(t,5)=lanedata(t,vr,82);
    sm1(t,6)=lanedata(t,vr,170);
    sm1(t,7)=lanedata(t,vr,171);
    mn=0;
    j=0;
    for i=1:7
        if sm1(t,i)>-10
            j=j+1;
            mn=mn+sm1(t,i);
        end
    end    
    sm1(t,8)=mn/j; 
    sm(t,1)=1969+t;
    sm(t,2)=100*mn/j;
end   

vr=37;
for t=1:38
    sm2(t,1)=lanedata(t,vr,28);
    sm2(t,2)=lanedata(t,vr,58);
    sm2(t,3)=lanedata(t,vr,62);
    sm2(t,4)=lanedata(t,vr,80);
    sm2(t,5)=lanedata(t,vr,82);
    sm2(t,6)=lanedata(t,vr,170);
    sm2(t,7)=lanedata(t,vr,171);
    mn=0;
    j=0;
    for i=1:7
        if sm2(t,i)>-10
            j=j+1;
            mn=mn+sm2(t,i);
        end
    end    
    sm2(t,8)=mn/j;  
    sm(t,3)=mn/j;
end  

vr=38;
for t=1:38
    sm3(t,1)=lanedata(t,vr,28);
    sm3(t,2)=lanedata(t,vr,58);
    sm3(t,3)=lanedata(t,vr,62);
    sm3(t,4)=lanedata(t,vr,80);
    sm3(t,5)=lanedata(t,vr,82);
    sm3(t,6)=lanedata(t,vr,170);
    sm3(t,7)=lanedata(t,vr,171);
    mn=0;
    j=0;
    for i=1:7
        if sm3(t,i)>-10
            j=j+1;
            mn=mn+sm3(t,i);
        end
    end    
    sm3(t,8)=mn/j;  
    sm(t,4)=mn/j;
end  

vr=47;
for t=1:38
    sm4(t,1)=lanedata(t,vr,28);
    sm4(t,2)=lanedata(t,vr,58);
    sm4(t,3)=lanedata(t,vr,62);
    sm4(t,4)=lanedata(t,vr,80);
    sm4(t,5)=lanedata(t,vr,82);
    sm4(t,6)=lanedata(t,vr,170);
    sm4(t,7)=lanedata(t,vr,171);
    mn=0;
    j=0;
    for i=1:7
        if sm4(t,i)>-10
            j=j+1;
            mn=mn+sm4(t,i);
        end
    end    
    sm4(t,8)=mn/j;  
    sm(t,5)=mn/j;
end  

vr=46;
for t=1:38
    sm5(t,1)=lanedata(t,vr,28);
    sm5(t,2)=lanedata(t,vr,58);
    sm5(t,3)=lanedata(t,vr,62);
    sm5(t,4)=lanedata(t,vr,80);
    sm5(t,5)=lanedata(t,vr,82);
    sm5(t,6)=lanedata(t,vr,170);
    sm5(t,7)=lanedata(t,vr,171);
    mn=0;
    j=0;
    for i=1:7
        if sm5(t,i)>-10
            j=j+1;
            mn=mn+sm5(t,i);
        end
    end    
    sm5(t,8)=mn/j;  
    sm(t,6)=(mn/j)/2;
end  

vr=39;
for t=1:38
    sm6(t,1)=lanedata(t,vr,28);
    sm6(t,2)=lanedata(t,vr,58);
    sm6(t,3)=lanedata(t,vr,62);
    sm6(t,4)=lanedata(t,vr,80);
    sm6(t,5)=lanedata(t,vr,82);
    sm6(t,6)=lanedata(t,vr,170);
    sm6(t,7)=lanedata(t,vr,171);
    mn=0;
    j=0;
    for i=1:7
        if sm6(t,i)>-10
            j=j+1;
            mn=mn+sm6(t,i);
        end
    end    
    sm6(t,8)=mn/j;  
    sm(t,7)=mn/j;
end  

for j=1:7
    tb(j,1)=100*mean(sm1(1:20,j));
    tb(j,2)=100*mean(sm1(21:38,j));
    tb(j,3)=mean(sm3(1:20,j));
    tb(j,4)=mean(sm3(21:38,j));
end    

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

figure(1)

set(0,'DefaultAxesColorOrder',[0,0,0])
set(0,'DefaultAxesLineWidth',0.75)
set(0,'DefaultLineLineWidth',0.7)
set(0,'DefaultAxesLineStyle','-d')
set(0,'DefaultLineMarkerSize',1.5)
set(0,'DefaultLineMarkerFaceColor',[0,0,0])

set(gcf, 'PaperType', 'usletter');
set(gcf,'PaperPositionMode','manual');
set(gcf, 'PaperPosition', [1.5 0.5 18.57 25.92]);
set(gcf,'Position',[200,50,600,800]);


h=subplot(3,2,1);
plot(sm(:,1),sm(:,2));
title('(a) Gross portfolio (% of GDP)')
axis([1970 2010 0 250]);

subplot(3,2,2);
plot(sm(:,1),sm(:,4));
title('(b) StDev of CPI inflation (%)')
axis([1970 2010 0 5]);

subplot(3,2,3);
plot(sm(:,1),sm(:,3));
title('(c) Chinn-Ito index')
axis([1970 2010 0 3]);

subplot(3,2,4);
plot(sm(:,1),sm(:,5));
title('(d) StDev of GDP growth (%)')
axis([1970 2010 0 3]);

subplot(3,2,5);
plot(sm(:,1),sm(:,6));
title('(e) Trade (% of GDP)')
axis([1970 2010 0 30]);

subplot(3,2,6);
plot(sm(:,1),sm(:,7));
title('(f) StDev of change in exch rate (%)')
axis([1970 2010 0 10]);

h = axes('Position',[0 0 1 1],'Visible','off','XLim',[0 1],'YLim',[0 1]);
text(0.51,0.98,'Figure 1: Average of G7 data','HorizontalAlignment','center');



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

ix=1;
for ic=1:179
    if cix1(ic,3)==1;
        
        dsx{ix,1}=data{ic,1};
        
        ds(ix,1)=100*mean(lanedata(1:20,41,ic));
        ds(ix,2)=100*mean(lanedata(21:38,41,ic));

        ds(ix,3)=mean(lanedata(1:20,38,ic));
        ds(ix,4)=mean(lanedata(21:38,38,ic));
        
        ix=ix+1;
    end
end 

[nr,nc]=size(ds);

for i=1:nr
    for j=1:nc
        if isnan(ds(i,j))~=1;
            dsx{i,j+1}=num2str(ds(i,j), '% 10.2f');
        else
            dsx{i,j+1}=' ';
        end    
    end
end   

odr=[4 7 8 11 12 19 20 1 2 3 5 6 9 10 13 14 15 16 17 18];

fid = fopen('table1.txt','w');

fprintf(fid,'\n\n\n\n\n\n\n\n%52s\n\n','Table 1: Summary of data for G7 and G22');
fprintf(fid,'%14s %19s %20s \n','  ','Gross Portfolio','SD Inflation  ');
fprintf(fid,'%14s %19s %20s \n\n','  ','70-89     90-07','70-89     90-07');
for ii=1:20
    ic=odr(ii);
    fprintf(fid,'%-14s',dsx{ic,1});
    for j=1:4
        if j==3  
            fprintf(fid,'%1s',' ');
        end 
        if j==1 | j==2
            if isnan(ds(ic,j))~=1
                fprintf(fid,'%10.0f',ds(ic,j)); 
            else
                fprintf(fid,'%10s',' ');
            end
        else
            if isnan(ds(ic,j))~=1
                fprintf(fid,'%10.2f',ds(ic,j)); 
            else
                fprintf(fid,'%10s',' ');
            end
        end    
    end    
    fprintf(fid,'\n',' ');
    if ii==7 
        fprintf(fid,'\n',' ');
    end    
end

fprintf(fid,'\n',' ');

