% Devereux, Senay and Sutherland (2013) Figure 3

clear all

% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

mfile='dss-matlab-model.txt';

[A1,A2,A3,A4,A5,NN,SIGMA,Z,nd,ns,nb,ne,nu,model] = modloadt(mfile);

% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

nx=ne;
ns=nb;
nc=nu;

BB=zeros(nb+nu,1);

eval(model{1});
eval(model{2});

dr={'re1','re2','rb1','rb2'};

[dm,na]=size(dr);
for i=1:na
    ia(i)=inx(dr{i},Z)-ns-nx;
end

iW=inx('BX',Z);

icd=inx('cd',Z)-ns-nx;

BB(iW,1)=1;

iyx=inx('yx',Z)-ns-nx;

ire1=inx('re1',Z)-ns-nx;
ire2=inx('re2',Z)-ns-nx;
irb1=inx('rb1',Z)-ns-nx;
irb2=inx('rb2',Z)-ns-nx;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

val=0.2;

for ip=1:25;

RS(ip,1)=val+1.1;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

[A1,A2,A3,A4,A5,NN,SIGMA]=modeval(model,'DT',val,'HB',0.0,'ET',0.0);

% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

[F1, F2, F3, P1, P2, P3] = ls_solution(A1, A2, A3, BB, NN, nx, ns, nc);

[Q, M, nq] = ls2ds(F1, F2, P1, P2, P3, NN, 0);

% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

for i=1:na-1
    R1(i,:)=Q{ia(i),1}-Q{ia(na),1};
    R2(i,:)=Q{ia(i),2}-Q{ia(na),2};
end    

D1=Q{icd,1};
D2=Q{icd,2};

% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

alpha1=inv(R2*SIGMA*D2'*R1'-R2*SIGMA*R2'*D1)*R2*SIGMA*D2';

af=[alpha1; -sum(alpha1)];

RS(ip,2:na+1)=af(:);

% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

At1=A1;
At2=A2;
At3=A3;

for i=1:na-1
    At2(iW,ia(i)+ns)=alpha1(i);  
end
At2(iW,ia(na)+ns)=A2(iW,ia(na)+ns)-sum(alpha1);  

[Ft1, Ft2, Ft3, Pt1, Pt2, Pt3] = ls_solution(At1, At2, At3, BB, NN, nx, ns, nc);

% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

YD=Pt1(iyx,:);

RX(1,:)=Pt1(ire1,:)-Pt1(ire2,:);
RX(2,:)=Pt1(irb1,:)-Pt1(irb2,:);

VRR=RX*SIGMA*RX';
VRY=RX*SIGMA*YD';

alpha2=-(1/2)*inv(VRR)*VRY;

XX=[RX; YD];
SS=XX*SIGMA*XX';

v1=SS(1,1)-SS(1,2)*SS(1,2)/SS(2,2);
v2=SS(2,2)-SS(1,2)*SS(1,2)/SS(1,1);

vy1=SS(3,3)-SS(2,3)*SS(2,3)/SS(2,2);
vy2=SS(3,3)-SS(1,3)*SS(1,3)/SS(1,1);

s1=v1^(1/2);
s2=v2^(1/2);

sy1=vy1^(1/2);
sy2=vy2^(1/2);

cy1=SS(1,3)-SS(1,2)*SS(2,3)/SS(2,2);
cy2=SS(2,3)-SS(1,2)*SS(1,3)/SS(1,1);

cr1=cy1/(s1*sy1);
cr2=cy2/(s2*sy2);

ae=-(1/2)*cr1*sy1/s1;
ab=-(1/2)*cr2*sy2/s2;

RS(ip,na+2)=-ae;
RS(ip,na+3)=-ab;

RS(ip,na+4)=cr1;
RS(ip,na+5)=cr2;

RS(ip,na+6)=s1;
RS(ip,na+7)=s2;

RS(ip,na+8)=sy1;
RS(ip,na+9)=sy2;

RS(ip,na+10)=RX(1,1);
RS(ip,na+11)=RX(1,4);
RS(ip,na+12)=RX(2,1);
RS(ip,na+13)=RX(2,4);
RS(ip,na+14)=YD(1,1);
RS(ip,na+15)=YD(1,4);

% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

GP=[NN zeros(nx,ns); Ft1 Ft2];
FP=[eye(nx,nx) zeros(nx,ns); zeros(ns,nx) eye(ns,ns); Pt1 Pt2];
LP=[eye(nx,nx); zeros(ns,nx)];
X=LP*SIGMA*LP';
V1=FP*X*FP';
ipi=inx('pi1',Z);
iy=inx('y1',Z);
iyd=inx('yd',Z);
iyxx=inx('yx',Z);
iiv=inx('Iv1',Z);
irex=inx('rxe',Z);
irbx=inx('rxb',Z);
iq=inx('yq',Z);
iS=inx('S',Z);
RS(ip,na+16)=100*V1(ipi,ipi)^0.5;
RS(ip,na+17)=100*V1(iy,iy)^0.5;
RS(ip,na+18)=V1(iyd,iyd)^0.5;
RS(ip,na+19)=V1(iyxx,iyxx)^0.5;
RS(ip,na+20)=RS(ip,na+19)/RS(ip,na+18);
RS(ip,na+21)=100*V1(iy,iy)^0.5;
RS(ip,na+22)=100*V1(iiv,iiv)^0.5;
RS(ip,na+23)=100*V1(iS,iS)^0.5;
RST(ip,1)=val+1.1;
RST(ip,2)=100*V1(iyxx,iyxx)^0.5;
RST(ip,3)=100*sy1;
RST(ip,4)=100*sy2;
RST(ip,5)=100*V1(irex,irex)^0.5;
RST(ip,6)=100*V1(irbx,irbx)^0.5;
RST(ip,7)=100*s1;
RST(ip,8)=100*s2;
RST(ip,9)=-V1(irex,iyxx)/((V1(irex,irex)^0.5)*(V1(iyxx,iyxx)^0.5));
RST(ip,10)=-V1(irbx,iyxx)/((V1(irbx,irbx)^0.5)*(V1(iyxx,iyxx)^0.5));
RST(ip,11)=cr1;
RST(ip,12)=cr2;

val=val+0.2;

end

% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

figure(1);

set(0,'DefaultAxesColorOrder',[0,0,0])
set(0,'DefaultAxesLineWidth',0.75)
set(0,'DefaultLineLineWidth',0.7)
set(0,'DefaultAxesLineStyle','-d')
set(0,'DefaultLineMarkerSize',1.5)
set(0,'DefaultLineMarkerFaceColor',[0,0,0])

set(gcf, 'PaperType', 'usletter');
set(gcf,'PaperPositionMode','manual');
set(gcf, 'PaperPosition', [1.5 0.5 18.57 25.92]);
set(gcf,'Position',[50,50,690,900]);

bs=0.12;
ht=0.108;
sp=0.06;

set(0,'DefaultAxesFontSize',7);

subplot(5,2,1); 
spp=get(gca,'Position');
spp(2)=bs+4*(ht+sp);
spp(4)=ht;
set(gca,'Position',spp);
plot(RS(:,1), RS(:,6));
xlim([1,6]);

subplot(5,2,2); 
spp=get(gca,'Position');
spp(2)=bs+4*(ht+sp);
spp(4)=ht;
set(gca,'Position',spp);
plot(RS(:,1), RS(:,7));
xlim([1,6]);

subplot(5,2,3); 
spp=get(gca,'Position');
spp(2)=bs+3*(ht+sp);
spp(4)=ht;
set(gca,'Position',spp);
plot(RS(:,1), RS(:,8));
ylim([-1.1,1.1]);
xlim([1,6]);

subplot(5,2,4); 
spp=get(gca,'Position');
spp(2)=bs+3*(ht+sp);
spp(4)=ht;
set(gca,'Position',spp);
plot(RS(:,1), RS(:,9));
ylim([-1.1,1.1]);
xlim([1,6]);

subplot(5,2,5); 
spp=get(gca,'Position');
spp(2)=bs+2*(ht+sp);
spp(4)=ht;
set(gca,'Position',spp);
plot(RS(:,1), RS(:,12));
xlim([1,6]);

subplot(5,2,6); 
spp=get(gca,'Position');
spp(2)=bs+2*(ht+sp);
spp(4)=ht;
set(gca,'Position',spp);
plot(RS(:,1), RS(:,13));
xlim([1,6]);

subplot(5,2,7); 
spp=get(gca,'Position');
spp(2)=bs+1*(ht+sp);
spp(4)=ht;
set(gca,'Position',spp);
plot(RS(:,1), RS(:,10));
xlim([1,6]);

subplot(5,2,8);
spp=get(gca,'Position');
spp(2)=bs+1*(ht+sp);
spp(4)=ht;
set(gca,'Position',spp);
plot(RS(:,1), RS(:,11));
xlim([1,6]);

subplot(5,2,9); 
spp=get(gca,'Position');
spp(2)=bs+0*(ht+sp);
spp(4)=ht;
set(gca,'Position',spp);
plot(RS(:,1), RS(:,20));
xlim([1,6]);

subplot(5,2,10);
spp=get(gca,'Position');
spp(2)=bs+0*(ht+sp);
spp(4)=ht;
set(gca,'Position',spp);
plot(RS(:,1), RS(:,21));
xlim([1,6]);

h = axes('Position',[0 0 1 1],'Visible','off');

ft1={'Figure 3: Inflation stabilization and gross portfolio holdings:'};
ft2={'Benchmark parameter values and local currency pricing'};
text(0.27,0.97,ft1,'HorizontalAlignment','left');
text(0.277,0.952,ft2,'HorizontalAlignment','left');

tbs=0.136;

text(0.30,0.1+tbs+0*(ht+sp),'(a) Equity holdings','FontSize',7,'HorizontalAlignment','center');
text(0.74,0.1+tbs+0*(ht+sp),'(b) Bond holdings','FontSize',7,'HorizontalAlignment','center');

text(0.30,0.1+tbs+1*(ht+sp),'(c) Corr(r_E,\zeta_y | r_B)','FontSize',7,'HorizontalAlignment','center');
text(0.74,0.1+tbs+1*(ht+sp),'(d) Corr(r_B,\zeta_y | r_E)','FontSize',7,'HorizontalAlignment','center');

text(0.30,0.1+tbs+2*(ht+sp),'(e) StDev(\zeta_y | r_B)','FontSize',7,'HorizontalAlignment','center');
text(0.74,0.1+tbs+2*(ht+sp),'(f) StDev(\zeta_y | r_E)','FontSize',7,'HorizontalAlignment','center');

text(0.30,0.1+tbs+3*(ht+sp),'(g) StDev(r_E | r_B)','FontSize',7,'HorizontalAlignment','center');
text(0.74,0.1+tbs+3*(ht+sp),'(h) StDev(r_B | r_E)','FontSize',7,'HorizontalAlignment','center');

text(0.30,0.1+tbs+4*(ht+sp),'(i) StDev of inflation','FontSize',7,'HorizontalAlignment','center');
text(0.74,0.1+tbs+4*(ht+sp),'(j) StDev of output','FontSize',7,'HorizontalAlignment','center');

text(0.30,0.1+0*(ht+sp),'Inflation feedback coefficient: \chi','FontSize',7,'HorizontalAlignment','center');
text(0.74,0.1+0*(ht+sp),'Inflation feedback coefficient: \chi','FontSize',7,'HorizontalAlignment','center');

text(0.30,0.1+1*(ht+sp),'Inflation feedback coefficient: \chi','FontSize',7,'HorizontalAlignment','center');
text(0.74,0.1+1*(ht+sp),'Inflation feedback coefficient: \chi','FontSize',7,'HorizontalAlignment','center');

text(0.30,0.1+2*(ht+sp),'Inflation feedback coefficient: \chi','FontSize',7,'HorizontalAlignment','center');
text(0.74,0.1+2*(ht+sp),'Inflation feedback coefficient: \chi','FontSize',7,'HorizontalAlignment','center');

text(0.30,0.1+3*(ht+sp),'Inflation feedback coefficient: \chi','FontSize',7,'HorizontalAlignment','center');
text(0.74,0.1+3*(ht+sp),'Inflation feedback coefficient: \chi','FontSize',7,'HorizontalAlignment','center');

text(0.30,0.1+4*(ht+sp),'Inflation feedback coefficient: \chi','FontSize',7,'HorizontalAlignment','center');
text(0.74,0.1+4*(ht+sp),'Inflation feedback coefficient: \chi','FontSize',7,'HorizontalAlignment','center');

