% Devereux, Senay and Sutherland (2013) Figure 6

clear all

% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

mfile='dss-matlab-model.txt';

[A1,A2,A3,A4,A5,NN,SIGMA,Z,nd,ns,nb,ne,nu,model] = modloadt(mfile);

% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

nx=ne;
ns=nb;
nc=nu;

BB=zeros(nb+nu,1);

eval(model{1});
eval(model{2});

dr={'re1','re2','rb1','rb2'};

[dm,na]=size(dr);
for i=1:na
    ia(i)=inx(dr{i},Z)-ns-nx;
end

iW=inx('BX',Z);

icd=inx('cd',Z)-ns-nx;

BB(iW,1)=1;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

pvar{1}='SB';pval(1)=0.003;
pvar{2}='BM';pval(2)=1;
pvar{3}='CP';pval(3)=0;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

for fn=1:3

    val=0.2;
    
    for ip=1:25;
        
        RST(ip,1)=val+1.1;
        
        [A1,A2,A3,A4,A5,NN,SIGMA]=modeval(model,'DT',val,pvar{fn},pval(fn));
        
        [F1, F2, F3, P1, P2, P3] = ls_solution(A1, A2, A3, BB, NN, nx, ns, nc);
        
        [Q, M, nq] = ls2ds(F1, F2, P1, P2, P3, NN, 0);
        
        for i=1:na-1
            R1(i,:)=Q{ia(i),1}-Q{ia(na),1};
            R2(i,:)=Q{ia(i),2}-Q{ia(na),2};
        end
        
        D1=Q{icd,1};
        D2=Q{icd,2};
        
        alpha1=inv(R2*SIGMA*D2'*R1'-R2*SIGMA*R2'*D1)*R2*SIGMA*D2';
        
        af=[alpha1; -sum(alpha1)];
        
        RST(ip,2)=af(2);
        RST(ip,3)=af(4);
        
        val=val+0.2;
        
    end
    
    RS(:,:,fn)=RST;

end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

iy1=inx('y1',Z)-ns-nx;
iy2=inx('y2',Z)-ns-nx;

iyfx1=inx('yfx1',Z)-nx;
iyfx2=inx('yfx2',Z)-nx;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

maxt=25;

for fn=4:5; 
    
    if fn==4
        pval=1;
    end
    if fn==5
        pval=0;
    end    

    val=0.2;
    
    RST=zeros(20,3);
    
    for ip=1:maxt;
        
        R1=zeros(na-1,1);
        R2=zeros(na-1,nx);
        
        RST(ip,1)=val+1.1;
        
        % first-order solution
        
        [A1,A2,A3,A4,A5,NN,SIGMA]=modeval(model,'DT',10000,'GM',0.00,'GW',0.00,'DY',0.00,'SV',0.0,'CP',1,'FW',0);
        
        [F1, F2, F3, P1, P2, P3] = ls_solution(A1, A2, A3, BB, NN, nx, ns, nc);
        
        [Q, M, nq] = ls2ds(F1, F2, P1, P2, P3, NN, 0);
        
        % calculate alpha-tilde
        
        for i=1:na-1
            R1(i,:)=Q{ia(i),1}-Q{ia(na),1};
            R2(i,:)=Q{ia(i),2}-Q{ia(na),2};
        end
        
        D1=Q{icd,1};
        D2=Q{icd,2};
        
        alpha0=inv(R2*SIGMA*D2'*R1'-R2*SIGMA*R2'*D1)*R2*SIGMA*D2';
        
        % form A-tilde matrices
        
        At1=A1;
        At2=A2;
        At3=A3;
        
        for i=1:na-1
            At2(iW,ia(i)+ns)=alpha0(i);
        end
        At2(iW,ia(na)+ns)=A2(iW,ia(na)+ns)-sum(alpha0);
        
        % first-order solution
        
        [Ft1, Ft2, Ft3, Pt1, Pt2, Pt3] = ls_solution(At1, At2, At3, BB, NN, nx, ns, nc);
        
        % %%%%%%%%%%%%%%%%%%%%
        
        t11=Pt1(iy1,:);
        t12=Pt1(iy2,:);
        
        t21=Pt2(iy1,:);
        t22=Pt2(iy2,:);
        
        % %%%%%%%%%%%%%%%%%%%%
        
        [A1,A2,A3,A4,A5,NN,SIGMA]=modeval(model,'DT',val,'CP',pval);
        
        A3(iyfx1,:)=t11;
        A3(iyfx2,:)=t12;
        
        A2(iyfx1,1:ns)=t21;
        A2(iyfx2,1:ns)=t22;
        
        % first-order solution
        
        [F1, F2, F3, P1, P2, P3] = ls_solution(A1, A2, A3, BB, NN, nx, ns, nc);
        
        [Q, M, nq] = ls2ds(F1, F2, P1, P2, P3, NN, 0);
        
        % calculate alpha-tilde
        
        for i=1:na-1
            R1(i,:)=Q{ia(i),1}-Q{ia(na),1};
            R2(i,:)=Q{ia(i),2}-Q{ia(na),2};
        end
        
        D1=Q{icd,1};
        D2=Q{icd,2};
        
        % %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
        
        alpha1=inv(R2*SIGMA*D2'*R1'-R2*SIGMA*R2'*D1)*R2*SIGMA*D2';
        
        af=[alpha1; -sum(alpha1)];
        
        RST(ip,2)=af(2);
        RST(ip,3)=af(4);
        
        % %%%%%%%%%%%%%%%%%%%%
        
        val=val+0.2;
        
    end
    
    RS(:,:,fn)=RST;
 
end

% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


pt{1}='(a) \sigma_\epsilon=0.003, Equities';
pt{2}='(b) \sigma_\epsilon=0.003, Bonds';
pt{3}='(c) one-period bonds, Equities';
pt{4}='(d) one-period bonds, Bonds';
pt{5}='(e) PPI targeting, Equities';
pt{6}='(f) PPI targeting, Bonds';
pt{7}='(g) flexible price output gap, Equities';
pt{8}='(h) flexible price output gap, Bonds';
pt{9}='(i) PPI targeting and flexible price output gap, Equities';
pt{10}='(j)PPI targeting and flexible price output gap, Bonds';

figure(1);

set(0,'DefaultAxesFontSize',7);
set(0,'DefaultAxesColorOrder',[0,0,0])
set(0,'DefaultAxesLineWidth',0.75)
set(0,'DefaultLineLineWidth',0.7)
set(0,'DefaultAxesLineStyle','-d')
set(0,'DefaultLineMarkerSize',1.5)
set(0,'DefaultLineMarkerFaceColor',[0,0,0])

set(gcf, 'PaperType', 'usletter');
set(gcf,'PaperPositionMode','manual');
set(gcf, 'PaperPosition', [1.5 0.5 18.57 25.92]);
set(gcf,'Position',[50,50,690,900]);


xtk=[1 2 3 4 5];
xlm=[1 5];

ylm{1}=[3 10];
ylm{2}=[-1 3];
ylm{3}=[10 17];
ylm{4}=[-3 1];
ylm{5}=[3 10];
ylm{6}=[0 4];
ylm{7}=[10 17];
ylm{8}=[-4 0];
ylm{9}=[9 16];
ylm{10}=[0 4];

for i=1:10
    tmp=ylm{i};
    ps1(i)=tmp(1)-0.82;
    if ps1(i)<0
        ps1(i)=ps1(i)+0.3;
    end    
    ps2(i)=tmp(2);
end    

fnx=1;

for fn=1:5

    subplot(5,2,fnx);
    plot(RS(:,1,fn),RS(:,2,fn));
    xlim(xlm)
    ylim(ylm{fnx})
    set(gca,'XTick',xtk)
    title(pt{fnx},'FontSize',7,'Position',[3,ps2(fnx)]);
    xlabel('Inflation feedback coefficient: \chi','FontSize',7,'Position',[3,ps1(fnx)]);
    fnx=fnx+1;
    
    subplot(5,2,fnx);
    plot(RS(:,1,fn),RS(:,3,fn));
    xlim(xlm)
    ylim(ylm{fnx})
    set(gca,'XTick',xtk)
    title(pt{fnx},'FontSize',7,'Position',[3,ps2(fnx)]);
    xlabel('Inflation feedback coefficient: \chi','FontSize',7,'Position',[3,ps1(fnx)]);
    fnx=fnx+1;
    
end

h = axes('Position',[0 0 1 1],'Visible','off');

clear ft;
 
ft='Figure 6: Model variants.'; 

text(0.39,0.97,ft,'HorizontalAlignment','left');
