function varargout = modloadt(varargin);

nro=nargout;
nar=length(varargin);
mfile=varargin{1};

% toolbox version

vst=ver('symbolic');
vernum=str2num(vst.Version);

if vernum>=4.9
    verf=1;
else
    verf=0;
end  

fprintf('toolbox version flag %d\n',verf);

% load model %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

[model]=textread(mfile, '%s','delimiter','\n','commentstyle','matlab');

model=cellstr(model);

mtmp=model;

[nm,nx]=size(model);

j=1;
for i=1:nm
    tmp1=model{i};
    tmp2={deblank(strtok(tmp1,'%'))};
    tmp3=strcat(tmp2,'%');
    if strcmp(tmp3{1},'%')==0;
        model1{j,1}=tmp2{1};
        j=j+1;
    end    
end    

model=model1;

i=2;
j=1;
while strcmp(model{i}(1,1),'$')==0
    tmp=model{i};
    [lhs,rhs]=strtok(tmp,'=');
    rhs=strrep(rhs,'=','');
    rhs=strcat('-(',rhs,')');
    EQ{j,1}=strcat(lhs,rhs);
    i=i+1;
    j=j+1;
end 

neq=j-1;

if length(findstr(model{i+1},'='))>0 
    i=i+1;
    j=1;
    while strcmp(model{i}(1,1),'$')==0
        tmp=model{i};
        [name,def]=strtok(tmp,'=');
        def=strrep(def,'=','');
        def=strrep(def,'Et[','');
        def=strrep(def,'Eo[','');
        def=strrep(def,']','');
        Lds{j,1}=def;
        LL{j,1}=name;
        i=i+1;
        j=j+1;   
    end 
    nlm=j-1;
else
    if strcmp(model{i+1}(1,1),'$')==1
        i=i+1;
    end    
    nlm=0;
    LL{1,1}='xx'; 
end

i=i+1;
j=1;
while strcmp(model{i}(1,1),'$')==0
    Z{j,1}=model{i};
    i=i+1;
    j=j+1;
end  

nbv=j-1;

nb=j-1;
i=i+1;
k=1;
while strcmp(model{i}(1,1),'$')==0
    Z{j,1}=model{i};
    ES1{k,1}=strcat('Et',strrep(Z{j,1},'(t)','(t+1)'));
    ES2{k,1}=strrep(Z{j,1},'(t)','(t+1)');
    i=i+1;
    j=j+1;
    k=k+1;
end  

nsv=j-1-nbv;

nk=j-1-nb;
i=i+1;
while strcmp(model{i}(1,1),'$')==0
    Z{j,1}=model{i};
    i=i+1;
    j=j+1;
end 

ncv=j-1-nbv-nsv;

i=i+1;
j=1;
while strcmp(model{i}(1,1),'$')==0
    SH{j,1}=model{i};
    i=i+1;
    j=j+1;
end 

niv=j-1;

%if neq~=nbv+nsv+ncv
%    fprintf('Unequal number of equations and variables\n');
    fprintf('Number of equations     %d\n', neq);
    fprintf('Number of vars          %d\n', nbv+nsv+ncv);
    fprintf('Number of backward vars %d\n', nbv);
    fprintf('Number of shock vars    %d\n', nsv);
    fprintf('Number of other vars    %d\n', ncv);
    fprintf('Number of innovations   %d\n', niv);
%end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

if nar==1
    nm=length(model);
    prmx=model(i:nm);
else
    pfile=varargin{2};
    [prmx]=textread(pfile, '%s','delimiter','\n','commentstyle','matlab');
    prmx=cellstr(prmx);
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

[nd,nx]=size(Z);
[nl,nx]=size(LL);

ns=nb+nk;
nu=nd-ns;

zm='[';
zt='[';
zp='[';  
zf='[';
ezt='[';
ezf='[';   

for i=1:nd
    
    ZM=strrep(Z{i,1},'(t-1)','m2');
    ZM=strrep(ZM,'(t)','m1');
    
    ZT=strrep(Z{i,1},'(t-1)','m1');
    ZT=strrep(ZT,'(t)','t');
    
    ZP=strrep(Z{i,1},'(t)','p1');
    ZP=strrep(ZP,'(t-1)','t');  
   
    ZF=ZP;
    if i>ns
        ZF=strcat('Et',ZF);
    end  
    
    EZT=strcat('Eo',ZT);
    EZF=strcat('Eo',ZP);    
 
    zm=strcat(zm,',',ZM);
    zt=strcat(zt,',',ZT);
    zp=strcat(zp,',',ZP);  
    zf=strcat(zf,',',ZF);
    ezt=strcat(ezt,',',EZT);
    ezf=strcat(ezf,',',EZF);
    
    zmx{i,1}=ZM;
    ztx{i,1}=ZT;
    zpx{i,1}=ZP;
    zfx{i,1}=ZF;
    
end  

zm=strcat(zm,']');
zt=strcat(zt,']');
zp=strcat(zp,']');  
zf=strcat(zf,']');
ezt=strcat(ezt,']');
ezf=strcat(ezf,']');  
zm=strrep(zm,'[,','[');
zt=strrep(zt,'[,','[');
zp=strrep(zp,'[,','[');
zf=strrep(zf,'[,','[');
ezt=strrep(ezt,'[,','[');
ezf=strrep(ezf,'[,','[');

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

ll='[';

for i=1:nl
    LL{i}=strrep(LL{i},'(t)','t');
    ll=strcat(ll,',',LL{i});
end

ll=strcat(ll,']');
ll=strrep(ll,'[,','[');

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

eqc='[';

for ieq=1:nd    

    eq=EQ{ieq};
    eq=strrep(eq,']','');
    eq=strrep(eq,'Et[','Et'); 
    eq=strrep(eq,'Eo[','Eo');        
    
    for ish=1:nk
        eq=strrep(eq,ES1{ish,1},ES2{ish,1});
    end        
    
    eq=strrep(eq,'(t-2)','m2');
    eq=strrep(eq,'(t-1)','m1');
    eq=strrep(eq,'(t)','t');
    eq=strrep(eq,'(t+1)','p1');
    
    eqc=strcat(eqc,', ',eq);
    
end  

eqc=strcat(eqc,' ]');
eqc=strrep(eqc,'[,','[');

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

if verf==0
    a1=maple('jacobian',eqc,zf);
    a2=maple('jacobian',eqc,zt);
    a3=maple('jacobian',eqc,ll);
    b1=maple('jacobian',eqc,ezf);
    b2=maple('jacobian',eqc,ezt);
else
    a1=char(evalin(symengine,strcat('linalg::jacobian(',eqc,',',zf,')')));
    a2=char(evalin(symengine,strcat('linalg::jacobian(',eqc,',',zt,')')));
    a3=char(evalin(symengine,strcat('linalg::jacobian(',eqc,',',ll,')')));
    b1=char(evalin(symengine,strcat('linalg::jacobian(',eqc,',',ezf,')')));
    b2=char(evalin(symengine,strcat('linalg::jacobian(',eqc,',',ezt,')')));
end

a1=strrep(a1,'matrix','');
a1=strrep(a1,'],','];');

a2=strrep(a2,'matrix','');
a2=strrep(a2,'],','];');

a3=strrep(a3,'matrix','');
a3=strrep(a3,'],','];');

b1=strrep(b1,'matrix','');
b1=strrep(b1,'],','];');

b2=strrep(b2,'matrix','');
b2=strrep(b2,'],','];');

a2=strcat('-',a2);
a3=strcat('-',a3);
b2=strcat('-',b2);

nx=nd-ns;
nbs=num2str(nb);
nks=num2str(nk);
nxs=num2str(nx);

a4=strcat('[zeros(',nbs,',',nks,'); eye(',nks,'); zeros(',nxs,',',nks,')]');

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

if nlm>0
    
    sc='';
    ix=1;

    for il=1:nl;

        ld=Lds{il};
        ld=strrep(ld,'(t-2)','m2');
        ld=strrep(ld,'(t-1)','m1');
        ld=strrep(ld,'(t)','t');
        ld=strrep(ld,'(t+1)','p1');
        ld=strcat('(',ld,')/2');

        if verf==0
            drmi=maple('hessian',ld,zm);
            drti=maple('hessian',ld,zt);
            drpi=maple('hessian',ld,zp);
            
            drmi=strrep(drmi,']])',']],storage=sparse)');
            drmi=strrep(drmi,'matrix','Matrix');
            drmi=maple(drmi);
            
            drti=strrep(drti,']])',']],storage=sparse)');
            drti=strrep(drti,'matrix','Matrix');
            drti=maple(drti);
            
            drpi=strrep(drpi,']])',']],storage=sparse)');
            drpi=strrep(drpi,'matrix','Matrix');
            drpi=maple(drpi);
        end
        
        if verf==1
            vrs=symvar(sym(ld));
            
            [dm,nv]=size(vrs);
            
            iv1=2;
            iv2=2;
            iv3=2;
            vlm(1,1)=0;
            vlt(1,1)=0;
            vlp(1,1)=0;
            
            % old toolbox
            for iv=1:nv
                tmp=char(vrs(iv));
                t3{iv,1}=tmp;
                tmp1=inx(tmp,zmx);
                tmp2=inx(tmp,ztx);
                tmp3=inx(tmp,zpx);
                if tmp1>0
                    vlm(iv1,1)=tmp1;
                    vlm(1,1)=vlm(1,1)+1;
                    iv1=iv1+1;
                end
                if tmp2>0
                    vlt(iv2,1)=tmp2;
                    vlt(1,1)=vlt(1,1)+1;
                    iv2=iv2+1;
                end
                if tmp3>0
                    vlp(iv3,1)=tmp3;
                    vlp(1,1)=vlp(1,1)+1;
                    iv3=iv3+1;
                end
            end
            % new toolbox
            if vlm(1,1)>0
                drmi='{';
                nv=vlm(1,1);
                ndv=1;
                for iv=1:nv
                    for jv=1:nv
                        vi=vlm(iv+1,1);
                        vj=vlm(jv+1,1);
                        dr(ndv,1)=vi;
                        dr(ndv,2)=vj;
                        vci=zmx{vi,1};
                        vcj=zmx{vj,1};
                        mupc=strcat('diff(',ld,',',vci,',',vcj,')');
                        drv{ndv,1}=char(evalin(symengine,mupc));
                        drv(ndv,1)=strcat(')=',drv(ndv,1),''';');
                        drv(ndv,1)=strcat(num2str(vi),',',num2str(vj),drv(ndv,1));
                        drv(ndv,1)=strcat('''(',drv(ndv,1));
                        drmi=strcat(drmi,char(drv(ndv,1)));
                        ndv=ndv+1;
                    end
                end
                drmi=strcat(drmi,'}');
                drmi=strrep(drmi,';}','}');
            else
                drmi='{''}';
            end
            
            if vlt(1,1)>0
                drti='{';
                nv=vlt(1,1);
                ndv=1;
                for iv=1:nv
                    for jv=1:nv
                        vi=vlt(iv+1,1);
                        vj=vlt(jv+1,1);
                        dr(ndv,1)=vi;
                        dr(ndv,2)=vj;
                        vci=ztx{vi,1};
                        vcj=ztx{vj,1};
                        mupc=strcat('diff(',ld,',',vci,',',vcj,')');
                        drv{ndv,1}=char(evalin(symengine,mupc));
                        drv(ndv,1)=strcat(')=',drv(ndv,1),''';');
                        drv(ndv,1)=strcat(num2str(vi),',',num2str(vj),drv(ndv,1));
                        drv(ndv,1)=strcat('''(',drv(ndv,1));
                        drti=strcat(drti,char(drv(ndv,1)));
                        ndv=ndv+1;
                    end
                end
                drti=strcat(drti,'}');
                drti=strrep(drti,';}','}');
            else
                drti='{''}';
            end
            
            if vlp(1,1)>0
                drpi='{';
                nv=vlp(1,1);
                ndv=1;
                for iv=1:nv
                    for jv=1:nv
                        vi=vlp(iv+1,1);
                        vj=vlp(jv+1,1);
                        dr(ndv,1)=vi;
                        dr(ndv,2)=vj;
                        vci=zpx{vi,1};
                        vcj=zpx{vj,1};
                        mupc=strcat('diff(',ld,',',vci,',',vcj,')');
                        drv{ndv,1}=char(evalin(symengine,mupc));
                        drv(ndv,1)=strcat(')=',drv(ndv,1),''';');
                        drv(ndv,1)=strcat(num2str(vi),',',num2str(vj),drv(ndv,1));
                        drv(ndv,1)=strcat('''(',drv(ndv,1));
                        drpi=strcat(drpi,char(drv(ndv,1)));
                        ndv=ndv+1;
                    end
                end
                drpi=strcat(drpi,'}');
                drpi=strrep(drpi,';}','}');
            else
                drpi='{''}';
            end
            
            xx{il,1}=drmi;
            xx{il,2}=drti;
            xx{il,3}=drpi;
            
            Ldx{il,1}=ld;
        end
        % end of toolbox difference
        
        tmp=drmi;
        flg=',2)=-1;';
        
        if verf==0
            [rem,tmp]=strtok(tmp,'{');
            [tmp,rem]=strtok(tmp,'}');
            tmp=strcat(tmp,'''}');
            tmp=strrep(tmp,'{','{''');
            tmp=strrep(tmp,', (','''; ''(');
        end
        [dm,nc]=size(tmp);  
        if nc>4    
            tmp=eval(tmp);
            [nt,dm]=size(tmp);
            for ii=1:nt
                tmpi=tmp{ii};
                [lhs,rhs]=strtok(tmpi,'=');
                rhs=strrep(rhs,'=','');
                lhs=strrep(lhs,'(','');
                lhs=strrep(lhs,')','');
                [lhs1,lhs2]=strtok(lhs,',');
                lhs2=strrep(lhs2,',','');
                ie=str2num(lhs1);
                je=str2num(lhs2);
                if je==ie
                    tmp1=strcat('SC(',int2str(ix),',1)=',int2str(il),';');
                    tmp2=strcat('SC(',int2str(ix),flg);
                    tmp3=strcat('SC(',int2str(ix),',3)=',lhs1,';');
                    tmp4=strcat('SC(',int2str(ix),',4)=',lhs2,';');
                    tmp5=strcat('SC(',int2str(ix),',5)=',rhs,';');   
                    sc=strcat(sc,tmp1,tmp2,tmp3,tmp4,tmp5);
                    ix=ix+1;
                end 
                if je>ie
                    tmp1=strcat('SC(',int2str(ix),',1)=',int2str(il),';');
                    tmp2=strcat('SC(',int2str(ix),flg);
                    tmp3=strcat('SC(',int2str(ix),',3)=',lhs1,';');
                    tmp4=strcat('SC(',int2str(ix),',4)=',lhs2,';');
                    tmp5=strcat('SC(',int2str(ix),',5)=2*(',rhs,');');   
                    sc=strcat(sc,tmp1,tmp2,tmp3,tmp4,tmp5);
                    ix=ix+1;
                end
            end    
        end
        
        tmp=drti;
        flg=',2)=0;';
        if verf==0
            [rem,tmp]=strtok(tmp,'{');
            [tmp,rem]=strtok(tmp,'}');
            tmp=strcat(tmp,'''}');
            tmp=strrep(tmp,'{','{''');
            tmp=strrep(tmp,', (','''; ''(');
        end
        [dm,nc]=size(tmp);
        if nc>4
            tmp=eval(tmp);
            [nt,dm]=size(tmp);
            for ii=1:nt
                tmpi=tmp{ii};
                [lhs,rhs]=strtok(tmpi,'=');
                rhs=strrep(rhs,'=','');
                lhs=strrep(lhs,'(','');
                lhs=strrep(lhs,')','');
                [lhs1,lhs2]=strtok(lhs,',');
                lhs2=strrep(lhs2,',','');
                ie=str2num(lhs1);
                je=str2num(lhs2);   
                if je>=ie
                    tmp1=strcat('SC(',int2str(ix),',1)=',int2str(il),';');
                    tmp2=strcat('SC(',int2str(ix),flg);
                    tmp3=strcat('SC(',int2str(ix),',3)=',lhs1,';');
                    tmp4=strcat('SC(',int2str(ix),',4)=',lhs2,';');
                    if je==ie    
                        tmp5=strcat('SC(',int2str(ix),',5)=',rhs,';');   
                    else
                        tmp5=strcat('SC(',int2str(ix),',5)=2*(',rhs,');');   
                    end  
                    sc=strcat(sc,tmp1,tmp2,tmp3,tmp4,tmp5);
                    ix=ix+1;
                end
            end    
        end
        tmp=drpi;
        flg=',2)=1;';
        if verf==0
            [rem,tmp]=strtok(tmp,'{');
            [tmp,rem]=strtok(tmp,'}');
            tmp=strcat(tmp,'''}');
            tmp=strrep(tmp,'{','{''');
            tmp=strrep(tmp,', (','''; ''(');
        end
        [dm,nc]=size(tmp);
        if nc>4
            tmp=eval(tmp);
            [nt,dm]=size(tmp);
            for ii=1:nt
                tmpi=tmp{ii};
                [lhs,rhs]=strtok(tmpi,'=');
                rhs=strrep(rhs,'=','');
                lhs=strrep(lhs,'(','');
                lhs=strrep(lhs,')','');
                [lhs1,lhs2]=strtok(lhs,',');
                lhs2=strrep(lhs2,',','');
                ie=str2num(lhs1);
                je=str2num(lhs2);
                if je==ie
                    tmp1=strcat('SC(',int2str(ix),',1)=',int2str(il),';');
                    tmp2=strcat('SC(',int2str(ix),flg);
                    tmp3=strcat('SC(',int2str(ix),',3)=',lhs1,';');
                    tmp4=strcat('SC(',int2str(ix),',4)=',lhs2,';');
                    tmp5=strcat('SC(',int2str(ix),',5)=',rhs,';');   
                    sc=strcat(sc,tmp1,tmp2,tmp3,tmp4,tmp5);
                    ix=ix+1;
                end 
                if je>ie
                    tmp1=strcat('SC(',int2str(ix),',1)=',int2str(il),';');
                    tmp2=strcat('SC(',int2str(ix),flg);
                    tmp3=strcat('SC(',int2str(ix),',3)=',lhs1,';');
                    tmp4=strcat('SC(',int2str(ix),',4)=',lhs2,';');
                    tmp5=strcat('SC(',int2str(ix),',5)=2*(',rhs,');');   
                    sc=strcat(sc,tmp1,tmp2,tmp3,tmp4,tmp5);
                    ix=ix+1;
                end 
            end    
        end    
    end    

else
    sc='SC(1,1)=-1;';
end    

modelx=strcat('A1=',a1,'; A2=',a2,'; A3=',a3,'; A4=',a4,'; B1=',b1,'; B2=',b2,';',sc);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

[nm,nx]=size(prmx);

j=1;
for i=1:nm
    tmp1=prmx{i};
    tmp2={deblank(strtok(tmp1,'%'))};
    tmp3=strcat(tmp2,'%');
    if strcmp(tmp3{1},'%')==0;
        prmx1{j,1}=tmp2{1};
        j=j+1;
    end    
end    

prmx=prmx1;

[nm,nx]=size(prmx);

i=2;
j=1;
while strcmp(prmx{i}(1,1),'$')==0
    [name,val]=strtok(prmx{i},'=');
    val=strrep(val,'=','');
    prmn{j,1}=strrep(name,' ','');
    prme{j,1}=strrep(val,' ','');
    i=i+1;
    j=j+1;
end    

i=i+1;
j=1;
sigma='[';
while strcmp(prmx{i}(1,1),'$')==0
    tmp=prmx{i};
    sigma=strcat(sigma,';',tmp);
    i=i+1;
    j=j+1;
end    

sigma=strcat(sigma,'];');
sigma=strrep(sigma,'[;','SIGMA=[');

np=length(prmn);

parameval1='';
parameval2='';

for i=1:np
    tst=0;
    try
        eval(strcat(prme{i},';'));
    catch
        tst=1;
    end
    if tst==0
        parameval1=strcat(parameval1,prmn{i},'=',prme{i},';');
    else
        parameval2=strcat(parameval2,prmn{i},'=',prme{i},';');
    end    
end

%parameval1=strcat(parameval1,sigma);
parameval2=strcat(parameval2,sigma);

model={parameval1 parameval2 modelx};

model{4}=nd;
model{5}=ns;
model{6}=nb;
model{7}=nk;
model{8}=nu;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

if nro==15    
    [A1,A2,A3,A4,B1,B2,SC,SIGMA]=modeval(model);
    varargout{1}=A1;
    varargout{2}=A2;
    varargout{3}=A3;
    varargout{4}=A4;
    varargout{5}=B1;
    varargout{6}=B2;
    varargout{7}=SC;
    varargout{8}=SIGMA;
    varargout{9}=Z;
    varargout{10}=nd;
    varargout{11}=ns;    
    varargout{12}=nb;
    varargout{13}=nk;
    varargout{14}=nu; 
    varargout{15}=model;      
end  

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

if nro==14  
    [A1,A2,A3,A4,A5,NN,SIGMA]=modeval(model);
    varargout{1}=A1;
    varargout{2}=A2;
    varargout{3}=A3;
    varargout{4}=A4;
    varargout{5}=A5;
    varargout{6}=NN;
    varargout{7}=SIGMA;
    varargout{8}=Z;
    varargout{9}=nd;
    varargout{10}=ns;    
    varargout{11}=nb;
    varargout{12}=nk;
    varargout{13}=nu; 
    varargout{14}=model;  
end 
